package com.zipcoder.payment;

public class Check implements Payment {

    private Long id = 0L;
    private String payerName;
    private String routingNumber;
    private String accountNumber;

    public Check(Long id, String name, String routingNumber, String accountNumber) {
        this.id = id;
        this.payerName = name;
        this.routingNumber = routingNumber;
        this.accountNumber = accountNumber;

    }

    @Override
    public Long getId() {
        return this.id;
    }

    @Override
    public String getPayerName() {
        return this.payerName;
    }

    @Override
    public String getShortDescription() {
        return "Check " + this.payerName + " ***" + getAccountNumber().substring(getAccountNumber().length() - 4);
    }

    public void setId(Long id) {
        this.id = id;
    }

    public void setPayerName(String payerName) {
        this.payerName = payerName;
    }

    public String getRoutingNumber() {
        return routingNumber;
    }

    public void setRoutingNumber(String routingNumber) {
        this.routingNumber = routingNumber;
    }

    public String getAccountNumber() {
        return accountNumber;
    }

    public void setAccountNumber(String accountNumber) {
        this.accountNumber = accountNumber;
    }

    @Override
    public int compareTo(Payment other) {
        return this.getShortDescription().compareTo(other.getShortDescription());
    }
}
