package com.zipcoder.payment;

public class CreditCard implements Payment {

    private Long id = 0L;
    private String payerName;
    private String number;
    private int expiredMonth;
    private int expiredYear;

    public CreditCard(Long id, String name, String number, int month, int year) {
        this.id = id;
        this.payerName = name;
        this.number = number;
        this.expiredMonth = month;
        this.expiredYear = year;

    }


    @Override
    public Long getId() {
        return id;
    }

    @Override
    public String getPayerName() {
        return payerName;
    }

    @Override
    public String getShortDescription() {
        return "CC " + this.payerName + " " + getNumber().substring(getNumber().length() - 4) + " " + getExpiredMonth() + "/" + getExpiredYear();
    }

    public void setPayerName(String payerName) {
        this.payerName = payerName;
    }

    public String getNumber() {
        return number;
    }

    public void setNumber(String number) {
        this.number = number;
    }

    public int getExpiredMonth() {
        return expiredMonth;
    }

    public void setExpiredMonth(int expiredMonth) {
        this.expiredMonth = expiredMonth;
    }

    public int getExpiredYear() {
        return expiredYear;
    }

    public void setExpiredYear(int expiredYear) {
        this.expiredYear = expiredYear;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Override
    public int compareTo(Payment other) {
        return this.getShortDescription().compareTo(other.getShortDescription());
    }
}
