package com.zipcoder.payment;

import org.junit.Assert;
import org.junit.Test;

public class CheckTest {

    //Given
    Check check = new Check(1L,"Lauren Green", "55663849772", "89994325");
    Check check2 = new Check(2L,"Hayden Stewart", "00124568877", "67400023");

    @Test
    public void testId() {
        //When
        Long expected = 3L;
        check.setId(3L);
        Long actual = check.getId();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testName() {
        //When
        String expected = "Lauren Stewart";
        check.setPayerName("Lauren Stewart");
        String actual = check.getPayerName();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testRoutingNumber() {
        //When
        String expected = "55555555";
        check.setRoutingNumber("55555555");
        String actual = check.getRoutingNumber();

        //Then
        Assert.assertEquals(expected, actual);

    }


    @Test
    public void testAccountNumber() {
        //When
        String expected = "55555555";
        check.setAccountNumber("55555555");
        String actual = check.getAccountNumber();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testShortDescription() {
        //When
        String expected = "Check Hayden Stewart ***0023";
        String actual = check2.getShortDescription();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testComparable() {
        //When
        int expected = 0;
        int actual = check2.compareTo(check2);

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testComparable2() {
        //When
        boolean actual = false;
        int compare = 0;
        int result = check.compareTo(check2);
        if(result > compare) {
            actual = true;
        }

        //Then
        Assert.assertTrue(actual);

    }

    @Test
    public void testComparable3() {
        //When
        boolean actual = false;
        int compare = 0;
        int result = check2.compareTo(check);
        if(result < compare) {
            actual = true;
        }

        //Then
        Assert.assertTrue(actual);

    }
}
