package com.zipcoder.payment;

import org.junit.Assert;
import org.junit.Test;

public class CreditCardTest {

    //Given
    CreditCard creditCard = new CreditCard(1L, "Lauren Green", "55663849772", 12, 2022);
    CreditCard creditCard2 = new CreditCard(2L, "Hayden Stewart", "00124568877", 3, 2045);

    @Test
    public void testId() {
        //When
        Long expected = 3L;
        creditCard.setId(3L);
        Long actual = creditCard.getId();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testName() {
        //When
        String expected = "Lauren Stewart";
        creditCard.setPayerName("Lauren Stewart");
        String actual = creditCard.getPayerName();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testNumber() {
        //When
        String expected = "567891234";
        creditCard.setNumber("567891234");
        String actual = creditCard.getNumber();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testExpiredMonth() {
        //When
        int expected = 5;
        creditCard.setExpiredMonth(5);
        int actual = creditCard.getExpiredMonth();

        //Then
        Assert.assertEquals(expected, actual);

    }


    @Test
    public void testExpiredYear() {
        //When
        int expected = 2099;
        creditCard.setExpiredYear(2099);
        int actual = creditCard.getExpiredYear();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testShortDescription() {
        //When
        String expected = "CC Hayden Stewart 8877 3/2045";
        String actual = creditCard2.getShortDescription();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testComparable() {
        //When
        int expected = 0;
        int actual = creditCard2.compareTo(creditCard2);

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testComparable2() {
        //When
        boolean actual = false;
        int compare = 0;
        int result = creditCard.compareTo(creditCard2);
        if(result > compare) {
            actual = true;
        }

        //Then
        Assert.assertTrue(actual);

    }

    @Test
    public void testComparable3() {
        //When
        boolean actual = false;
        int compare = 0;
        int result = creditCard2.compareTo(creditCard);
        if(result < compare) {
            actual = true;
        }

        //Then
        Assert.assertTrue(actual);

    }

}
