package com.zipcoder.payment;

import org.junit.Assert;
import org.junit.Test;

public class PayPalTest {

    //Given
    PayPal customer = new PayPal(1L, "Lauren Green", "lauren@mail.com");
    PayPal customer2 = new PayPal(2L, "Hayden Stewart", "hayden@mail.com");

    @Test
    public void testId() {
        //When
        Long expected = 3L;
        customer.setId(3L);
        Long actual = customer.getId();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testName() {
        //When
        String expected = "Lauren Stewart";
        customer.setPayerName("Lauren Stewart");
        String actual = customer.getPayerName();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testEmail() {
        //When
        String expected = "lgreen@mail.com";
        customer.setEmail("lgreen@mail.com");
        String actual = customer.getEmail();

        //Then
        Assert.assertEquals(expected, actual);

    }


    @Test
    public void testShortDescription() {
        //When
        String expected = "PayPal Hayden Stewart hayden@mail.com";
        String actual = customer2.getShortDescription();

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testComparable() {
        //When
        int expected = 0;
        int actual = customer2.compareTo(customer2);

        //Then
        Assert.assertEquals(expected, actual);

    }

    @Test
    public void testComparable2() {
        //When
        boolean actual = false;
        int compare = 0;
        int result = customer.compareTo(customer2);
        if(result > compare) {
            actual = true;
        }

        //Then
        Assert.assertTrue(actual);

    }

    @Test
    public void testComparable3() {
        //When
        boolean actual = false;
        int compare = 0;
        int result = customer2.compareTo(customer);
        if(result < compare) {
            actual = true;
        }

        //Then
        Assert.assertTrue(actual);

    }

}
